// menu ovladane 3 tlacitky se zobrazovanim na displeji
//================================================

#ifdef displej_TM1637_5


#define AUTOEXITMENU        30000     //  po jake dobe necinnosti se menu automaticky opusti (cislo udava pocet smycek, jedna smycka trva 10ms) 
unsigned int auto_exit_menu;          // v teto promenne se bude odecitat doba necinnosti
unsigned long trvani_stisku;          // doba drzeni tlacitka OK v milisekundach v hlavnim menu
unsigned long trvani_stisku2;         // doba drzeni tlacitka OK v milisekundach v podmenu


int pozice_menu1 = 0;   // nalistovana pozice v hlavnim menu
                        // 0 = LIST           (listovani v poslednich namerenych hodnotach)
                        // 1 = Auto:          (nastaveni automatickeho zaznamu)
                        // 2 = ZonA:          (prepinani SEC/SELC)
                        // 3 = CALIb:         (zobrazeni a ulozeni jasu bez prepoctu)
                        // 4 = dAtuM:         (zobrazeni a moznost nastaveni datumu)
                        // 5 = CAS:           (zobrazeni a moznost nastaveni casu)
                        // 6 = tEPL:          (prubezne zobrazovani aktualni teploty)
                        // 7 = VLH:           (prubezne zobrazovani aktualni vlhkosti)
                        // 8 = JAS:           (prubezne zobrazovani aktualniho jasu)
                        // 9 = Ho-Mi          (prubezne zobrazovani aktualniho casu)
                        //10 = PruM:          (nastaveni prumerovani)
                        //11 = LEd            (regulovatelna cervena svitilna)
                        //12 = StoP           (Stopky)
                        //13 = GPS            (zobrazeni zemepisnych souradnic) - jen kdyz je pripojeny GPS modul a jsou k dispozici data


// listovani v hlavnim menu a volba polozky
void menu_1(void)
  {

#ifdef ukladat_GPS
    byte pocet_polozek_menu = 13;
#else
    byte pocet_polozek_menu = 12;
#endif

    if (pocet_polozek_menu == 13 and digitalRead(pin_EXT_ZAP) == HIGH)       // kdyz je v programu povolene GPS, ale to neni pripojene ...
      {
        pocet_polozek_menu = 12;                                             //   ... zustava maximalni pocet polozek v menu na 11 polozkach (konci polozkou "LED")
      }

    auto_exit_menu = AUTOEXITMENU;                                           // po 5 minutach bez stisku tlacitka se menu automaticky ukonci
    zobraz_text(pozice_menu1);

    while (digitalRead( pin_tl_ok) == LOW)                                   // do hlavniho menu se vstoupilo dlouhym stiskem tlacitka OK
      {                                                                      //  ted je nutne pockat na jeho uvolneni
        delay(50);
      }

    delay(50);
    
    while (auto_exit_menu)
      {
        interrupty();                                                        // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni
        zobraz_text(pozice_menu1);        
        
        if (digitalRead(pin_tl_up) == LOW)                                   // listovani nahoru v hlavnim menu
          {
            delay(50);                                                       // odruseni zakmitu
            pozice_menu1 --;
            if (pozice_menu1 < 0) pozice_menu1 = 0;
            zobraz_text(pozice_menu1);
            while (digitalRead(pin_tl_up) == LOW) delay(50);                 // dokud je tlacitko stisknute, nic se nedeje
            delay(50);                                                       // odruseni zakmitu
            auto_exit_menu = AUTOEXITMENU;
          }

    
        if (digitalRead(pin_tl_dn) == LOW)                                   // listovani dolu v hlavnim menu
          {
            delay(50);                                                       // odruseni zakmitu
            pozice_menu1 ++;
            if (pozice_menu1 > pocet_polozek_menu) pozice_menu1 = pocet_polozek_menu;
            zobraz_text(pozice_menu1);
            while (digitalRead(pin_tl_dn) == LOW) delay(50);                 // dokud je tlacitko stisknute, nic se nedeje
            delay(50);                                                       // odruseni zakmitu
            auto_exit_menu = AUTOEXITMENU;    
          }
    
      
    
        if (digitalRead(pin_tl_ok) == LOW)                                   // potvrzovaci tlacitko
          {
            delay(50);                                                       // odruseni zakmitu
            unsigned long startTime = millis();
            while (digitalRead( pin_tl_ok) == LOW)                           // dokud je tlacitko stisknute, nic se nedeje
              {
                delay(20);
                trvani_stisku = millis() - startTime;
                if (trvani_stisku > 500)                                     // stisk trval dele nez 0,5 sekundy
                  {
                    podmenu(pozice_menu1);                                   // skoci se do podmenu - pri navratu z menu zustava nastavena promenna 'trvani_stisku' na vysokou hodnotu, takze se hlavni menu neopusti
                  }
              }
            if (trvani_stisku <= 500)                                        // stisk tlacitka OK byl kratsi, nez 0,5 sekundy
              {
                auto_exit_menu = 1;                                          // pri kratkem stisku se opusti hlavni menu    
                delay(200);                                                  // pauza pred opustenim menu
              }
              
            
          }
        
        auto_exit_menu --;
        delay(10);
      
      }                                                                      // kdyz je auto_exit_menu = 0, menu se opousti

    zobraz_text(28);                                                         // pri opusteni menu se zhasne displej 
  
  }
//------------------------------------------



//------------------------------------------
void podmenu(byte polozka)
  {
    int zadano;
    zobraz_text(29);                                                         // vsechny jednotky zobrazi "-----" a ceka se na uvolneni tlacitka (v podprogramu plusminus)
    

    if (polozka == 0)                                                        // LIST
      {
        zadano = plusminus('L', list,0,99);

        if (bude_save == true)                                               // kdyz se z podprogramu 'plusminus()' vyskocilo dlouhym stiskem [OK], zobrazi se jedna polozka v EEPROM
          {
            list = zadano & 255;
            vypis_EEPROM(65531);
          }                                                                  // pri navratu z podporgramu 'plusminus()' kratkym stiskem [OK], se EEPROM nevypise a vrati se na polozku 'LIST'
      }

    
    
    if (polozka == 1)                                                        // pocet minut mezi automatickym merenim
      {
        zadano = plusminus('A', automat,0,255);
        EEPROM_update(10,zadano & 255);
        automat = zadano & 255;
        if (automat > 0)                                                    // pokud byl zadany nejaky casovy interval,
          {
            posledni_autospusteni = millis();                               // spusti se prvni mereni okamzite
            mereni(6);         
          }
      }



    if (polozka == 2)                                                        // SEC/SELC
      {
        zadano = plusminus('S', leto,0,1);
        EEPROM_update(8,zadano & 255);

        if ((zadano & 255) == 0) leto = false;
        else                     leto = true;
      }


    if (polozka == 3)                                                        // svetlo bez korekce pro kalibraci
      {
        while (digitalRead( pin_tl_ok) == LOW)                               // do podmenu se vstoupilo dlouhym stiskem tlacitka OK
          {                                                                  //  ted je nutne pockat na jeho uvolneni
            delay(20);
          } 

        delay(1000);
        mereni(7);                                                           //  prumeruje 10 vzorku, ale vystup vraci bez korekce. Na zaver vystledek zobrazi na displeji
        
        while (digitalRead( pin_tl_ok) == HIGH)                              // dokud je tlacitko OK uvolnene, je videt hodnota svetla bez korekce
          {
            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni            
            delay(20);

            if (digitalRead( pin_tl_up) == LOW)                              // prepnuti na zobrazeni posledni nezkorigovane teploty
              { 
                pozice_tecky = 2;                                            // teplota na 2 destinna mista
                zobraz_cislo((int_teplota  - 5000 ), 1);                          
                D_pamet[4] = znak_stupen; 
              }

            if (digitalRead( pin_tl_dn) == LOW)                              // prepnuti na zobrazeni posledniho nezkorigovaneho jasu
              {
                pozice_tecky = 3;                                            // svetlo na 3 desetinna mista   
                zobraz_cislo(int_svetlo , 0);
              }          
          } 
        
        delay(20);
      }



    if (polozka == 4)                                                        // datum
      {
        boolean pomprom_save = false;
        zobraz_RTC(leto, 0);                                                 // cas z RTC rozlozi do promennych "LOC_xxx" (vcetne korekci)
        
        // uprava promennych pomoci tlacitek       
        byte zadany_den = plusminus('d', LOC_den,1,31);
        if (bude_save == true) pomprom_save = true;

        byte zadany_mesic = plusminus('M', LOC_mes,1,12);
        if (bude_save == true) pomprom_save = true;

        if (LOC_rok < 2000) LOC_rok = 2000;                                  // kdyz jeste neni nastaveny cas v RTC, tak je rok nesmyslny, proto se upravi na '2000'
      
        byte zadany_rok = plusminus('r', LOC_rok - 2000,0,99);
        if (bude_save == true) pomprom_save = true;

                                                                             // v promennych 'zadany_den' (/ mesic / rok) jsou upravene hodnoty

        if (pomprom_save == true)
          {

            mtt.year     = zadany_rok + 2000 - 1970;                         // knihovna je napsana tak, ze se cas pocita od 1.1.1970
            mtt.month    = zadany_mesic;
            mtt.day      = zadany_den;
            mtt.hour     = LOC_hod;
            mtt.minute   = LOC_min;
            mtt.second   = LOC_sek;
            tt = rtclock.makeTime(mtt) - 3600;                               // v zime se pri ukladani casu uklada do RTC o hodinu mene (prevod SEC na GMT)
            if (leto == true) tt = tt - 3600;                                // kdyz se nastavuje cas v lete (SELC), do RTC se uklada o dalsi hodinu mene (prevod SELC na SEC)
            rtclock.setTime(tt);   

            cas_minuleho_nastaveni = 0;                                      // zruseni automatickych korekci casu
            korekce = 0x7FFFFFFFUL;
            EEPROM_write_long(0,cas_minuleho_nastaveni);                     // do EEPROM se ulozi cas posledniho nastaveni (aktualni cas) a vypoctena korekce
            EEPROM_write_long(4,korekce);            
          }
         
      }


    if (polozka == 5)                                                        // cas
      {
        boolean pomprom_save = false;
        zobraz_RTC(leto, 0);                                                 // cas z RTC rozlozi do promennych "LOC_xxx" (vcetne korekci)
        
        byte zadane_hodiny = plusminus('H', LOC_hod,0,23);
        if (bude_save == true) pomprom_save = true;
        

        byte zadane_minuty = plusminus('M', LOC_min,0,59);
        if (bude_save == true) pomprom_save = true;

        if (pomprom_save == true)
          {
            mtt.year     = LOC_rok - 1970;                                   // knihovna je napsana tak, ze se cas pocita od 1.1.1970
            mtt.month    = LOC_mes;
            mtt.day      = LOC_den;
            mtt.hour     = zadane_hodiny;
            mtt.minute   = zadane_minuty;
            mtt.second   = 0;
            tt = rtclock.makeTime(mtt) - 3600;                               // v zime se od zadavaneho casu odecte 1 hodina (prevod ze SEC na GMT)
            if (leto == true) tt = tt - 3600;                                // v lete se odecte jeste jedna hodina navic (prevod SELC na SEC)
            rtclock.setTime(tt);   

            cas_minuleho_nastaveni = 0;                                      // zruseni automatickych korekci casu
            korekce = 0x7FFFFFFFUL;
            EEPROM_write_long(0,cas_minuleho_nastaveni);                     // do EEPROM se ulozi cas posledniho nastaveni (aktualni cas) a vypoctena korekce
            EEPROM_write_long(4,korekce);  
          }
      }


    if (polozka == 6)                                                        // teplota
      {
        while (digitalRead(pin_tl_ok) == LOW)                                // do podmenu se vstoupilo dlouhym stiskem tlacitka OK
          {                                                                  //  ted je nutne pockat na jeho uvolneni
            delay(50);
          } 

        delay(50);
        byte pauza = 0;

        boolean s_korekci = true;                                            // pri vstupu do polozky se vzdycky nejdriv zobrazuje teplota s korekci podle kalibracni tabulky

        while (digitalRead( pin_tl_ok) == HIGH)                              // Dokud neni stisknuto tlacitko OK
          {
            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni
            
            pauza ++;
            if (pauza == 200)                                                // teplota se testuje kazde 2 sekundy (200 x 0.01s)
              {
                int pomprom = teplota(s_korekci);

                pauza = 0;
                D_pamet[4] = znak_stupen;                                    // znacka "stupen" pro mereni teploty na prvni zobrazovaci jednotce (rad desetitisicu)
                pozice_tecky = 2;
                zobraz_cislo((pomprom  - 5000 ), 1);

                
              }
            delay(10);  

            if (digitalRead(pin_tl_up) == LOW and digitalRead(pin_tl_dn) == LOW)             // funkce pro prepinani zobrazeni s korekci, nebo bez korekce
              {
                if (s_korekci == true)
                  {
                    s_korekci = false;
                    zobraz_text(32);                                         // "noCor"  (zobrazeni prubezne teploty bez korekce )
                  }
                else
                  {
                    s_korekci = true;
                    zobraz_text(33);                                         // " Corr"  (zobrazeni prubezne teploty s korekci )                    
                  }
                delay(50);
                while (digitalRead(pin_tl_up) == LOW or digitalRead(pin_tl_dn) == LOW) ;     // ceka na uvolneni obou tlacitek
                delay(50);
              }
          }       
      }


    if (polozka == 7)                                                        // vlhkost
      {
        while (digitalRead( pin_tl_ok) == LOW)                               // do podmenu se vstoupilo dlouhym stiskem tlacitka OK
          {                                                                  //  ted je nutne pockat na jeho uvolneni
            delay(50);
          } 

        delay(50);
        byte pauza = 0;
        while (digitalRead( pin_tl_ok) == HIGH)                              // Dokud neni stisknuto tlacitko OK
          {
            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni
            
            pauza ++;
            if (pauza == 200)                                                // vlhkost se testuje kazde 2 sekundy (200 x 0.01s)
              {
                unsigned int pomprom = vlhkost(); 
                pauza = 0;

                D_pamet[4] = znak_V;                                         // znacka "V" pro mereni vlhkosti na prvni zobrazovaci jednotce
                pozice_tecky = 2;
                zobraz_cislo(pomprom , 1);
              }
            delay(10);  
          } 
      }
        

    if (polozka == 8)                                                        // svetlo
      {
        while (digitalRead( pin_tl_ok) == LOW)                               // do podmenu se vstoupilo dlouhym stiskem tlacitka OK
          {                                                                  //  ted je nutne pockat na jeho uvolneni
            delay(50);
          } 

        delay(50);
        byte  pauza = 75;

        boolean s_korekci = true;                                            // pri vstupu do polozky se vzdycky nejdriv zobrazuje jas s korekci podle kalibracni tabulky

        while (digitalRead(pin_tl_ok) == HIGH)                               // Dokud neni stisknuto OK
          {
            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni

            if (pauza == 75)                                                 // svetlo se meri po 0,75 sekunde zobrazeni predchoziho mereni (75 x 0.01s)
              {
                pauza = 0;
                unsigned int pomprom = svetlo_1x(true,false);                // meri jen 1 vzorek - bez bargrafu, je mozne prerusit stiskem tlacitka OK
                if (pomprom == 65535)  break;                                // mereni bylo predcasne ukonceno tlacitkem, proto se ukonci nadrazena smycka while
                if (s_korekci == true)                                       // pokud je zapnuty korekcni prepocet ...
                  {
                    pomprom = korekce_svetla(pomprom);                       // ... proved pred zobrazenim korekci podle kalibracni tabulky                
                  }

                pozice_tecky = 3;
                zobraz_cislo(pomprom , 0);
                
              }

            if (digitalRead(pin_tl_up) == LOW and digitalRead(pin_tl_dn) == LOW)             // funkce pro prepinani zobrazeni s korekci, nebo bez korekce
              {
                if (s_korekci == true)
                  {
                    s_korekci = false;
                    zobraz_text(32);                                         // "noCor"  (zobrazeni prubezneho jasu bez korekce )
                  }
                else
                  {
                    s_korekci = true;
                    zobraz_text(33);                                         // " Corr"  (zobrazeni prubezneho jasu s korekci )                    
                  }
                delay(50);
                while (digitalRead(pin_tl_up) == LOW or digitalRead(pin_tl_dn) == LOW) ;     // ceka na uvolneni obou tlacitek
                delay(50);
              
              }
            
            pauza ++;
            delay(10);            
          } 
      }


    if (polozka == 9)                                                        // Ho-Mi
      {
        while (digitalRead( pin_tl_ok) == LOW)                               // do podmenu se vstoupilo dlouhym stiskem tlacitka OK
          {                                                                  //  ted je nutne pockat na jeho uvolneni
            delay(50);
          } 


        delay(50);
        byte pauza = 0;
        boolean blikon = false;                                              // pomocna promenna pro zjistovani stavu blikajici tecky mezi hodinama a minutama
        
        while (digitalRead( pin_tl_ok) == HIGH)                              // Dokud neni stisknuto tlacitko OK
          {
            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni
            

            pauza ++;

            if (pauza == 50)
              {
                D_pamet[2] = 0;                                              // pro prostredni displej se zrusi pomlcka mezi hodinami a minutami
               
                aktualizuj_displej();
              }
            
            if (pauza == 100)                                                // cas v RTC se zjistuje kazdou sekundu (100 x 0.01s)
              {
                zobraz_RTC(leto,false);

                if(LOC_hod < 10) D_pamet[4] = 0;                             // na pozici desitek hodin zapis mezeru
                else             D_pamet[4] = graf_def[LOC_hod / 10];        //  nebo desitky hodin
                D_pamet[3] = graf_def[LOC_hod % 10];                         // na pozici jednotek hodin zapis jednotky hodin + dvojtecka
                D_pamet[2] = 64;                                             // pro vetsi displej se mezi hodiny a minuty zapise pomlcka

                D_pamet[1] = graf_def[LOC_min / 10];                         // desitky minut
                D_pamet[0] = graf_def[LOC_min % 10];                         // jednotky minut

                aktualizuj_displej();
                pauza = 0;
              }
            delay(10);  
          } 
      }


    if (polozka == 10)                                                       // pocet vzorku svetla pro prumerovani svetla
      {
        zadano = plusminus('P', prumery,1,20);
        EEPROM_update(11,zadano & 255);
        prumery = zadano & 255;
      }


    if (polozka == 11)                                                       // funkce LED svitilna
      {
        svitilna();
      }


    if (polozka == 12)                                                       // funkce STOPKY
      {
        stopky();
      }


    if (polozka == 13)                                                       // GPS
      {
        while (digitalRead( pin_tl_ok) == LOW)                               // do podmenu se vstoupilo dlouhym stiskem tlacitka OK
          {                                                                  //  ted je nutne pockat na jeho uvolneni
            delay(50);
          } 

        delay(1000);
        gps(false);                                                          // pres I2C si stahne posledni souradnice (zprumerovane)
        int lat_alt_lon = 0;                                                 // znacka, ze se zobrazuje LAT
        disp_GPS(GPS_lat, 0 , true);                                         // na displeji se odscrolluje aktualni zemepisna sirka (LAT)
        byte pocitadlo_smycek = 0;
        while (digitalRead( pin_tl_ok) == HIGH)                              // dokud je tlacitko OK uvolnene, jsou zobrazeny souradnice
          {
            pocitadlo_smycek ++;
            if (pocitadlo_smycek == 40)                                      // kazde 2 sekundy (40*50ms)) se aktualizuji souradnice a potom se zobrazi poslednich 5 mist na displeji
              {
                pocitadlo_smycek = 0;
                gps(false);                                                  // pres I2C si stahne posledni souradnice (zprumerovane)
                
                if (lat_alt_lon == 0) disp_GPS(GPS_lat,  0, false);          // na displeji se zobrazi jen poslednich 5 mist z aktualni zemepisne sirky (LAT) - bez scrollovani
                if (lat_alt_lon == 1) disp_GPS(GPS_alt,  1, false);          // na displeji se zobrazi jen nadmorska vyska (ALT) - bez scrollovani
                if (lat_alt_lon == 2) disp_GPS(GPS_lon,  2, false);          // na displeji se zobrazi jen poslednich 5 mist z aktualni zemepisne delky (LON) - bez scrollovani

              }
            
            
            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni            

            if (digitalRead( pin_tl_up) == LOW)                              // prepnuti na nasledujici polozku LAT -> ALT -> LON
              { 
                lat_alt_lon = lat_alt_lon + 1;
                if (lat_alt_lon == 3) lat_alt_lon = 2;
                if (lat_alt_lon == 1)        disp_GPS(GPS_alt, 1, false);    // na displeji se zobrazi aktualni nadmorska vyska (ALT) - bez scrolovani
                if (lat_alt_lon == 2)        disp_GPS(GPS_lon, 2, true);     // na displeji se odscrolluje aktualni zemepisna sirka (LON)
                pocitadlo_smycek = 0;
              }
              
            if (digitalRead( pin_tl_dn) == LOW)                              // prepnuti na predchozi polozku LON -> ALT -> LAT
              {
                lat_alt_lon = lat_alt_lon - 1;
                if (lat_alt_lon < 0) lat_alt_lon = 0;
                if (lat_alt_lon == 0)        disp_GPS(GPS_lat, 0, true);     // na displeji se odscrolluje aktualni zemepisna sirka (LAT) - bez scrolovani
                if (lat_alt_lon == 1)        disp_GPS(GPS_alt, 1, false);    // na displeji se zobrazi aktualni nadmorska vyska (ALT) - bez scrolovani
                pocitadlo_smycek = 0;
              }
              
            while (digitalRead( pin_tl_up) == LOW or digitalRead( pin_tl_dn) == LOW)  // cekani na uvolneni tlacitka UP/DOWN
              {
                delay(50);
              }
            delay(50);          
          } 
        delay(20);

      }



    zobraz_text(pozice_menu1);

    while (digitalRead( pin_tl_ok) == LOW)                                   // z listovani se vraci dlouhym stiskem tlacitka OK
      {                                                                      //  ted je nutne pockat na jeho uvolneni
        delay(20);
      }
    
    delay(100);
  }
//------------------------------------------



//------------------------------------------
//  listovani v parametrech zvolene polozky o +/- 1 pomoci tlacitek nahoru adolu
int plusminus(char znak1, byte start_hodnota, int minimum, int maximum)
  {
    int vystup = start_hodnota;
    float potvrzeni = false;

    //--------------------------  zobrazeni puvodni hodnoty na displeji -------------------
    if (znak1 == 'A') D_pamet[4] =  znak_A;                                  // velke A
    if (znak1 == 'P') D_pamet[4] =  znak_P;                                  // velke P
    if (znak1 == 'd') D_pamet[4] =  znak_d;                                  // male d
    if (znak1 == 'M') D_pamet[4] =  znak_M;                                  // velke M
    if (znak1 == 'r') D_pamet[4] =  znak_r;                                  // male r
    if (znak1 == 'H') D_pamet[4] =  znak_H;                                  // velke H
    if (znak1 == 'L') D_pamet[4] =  znak_L;                                  // velke L

    D_pamet[3] = 0b00000000;                                                 // druha sedmisegmentovka zleva (rad tisicu) je prazdna


    if (znak1 == 'S')                                                        // casova zona je trochu jina, protoze nezobrazuje cisla, ale napisy SEC/SELC
      {
        zobraz_text(vystup+25);
      }
    else                                                                     // v ostatnich pripadech se zobrauje zadavane cislo bez tecky
      {
        pozice_tecky = 0;
        if (znak1 == 'L')
          {
            zobraz_cislo(vystup,2);            
          }
        else
          {
            zobraz_cislo(vystup,1);
          }
      }



    while (digitalRead( pin_tl_ok) == LOW)                                   // do listovani se vstoupilo dlouhym stiskem tlacitka OK
      {                                                                      //  ted je nutne pockat na jeho uvolneni
        delay(50);
      }

    delay(50);

    
    while (potvrzeni == false)
      {

        byte pompam4 = D_pamet[4];                                           // zapamatuje se stav displeje pred interruptem, ve ktere muze dojit k jeho zhasuti
        byte pompam3 = D_pamet[3];                                      
        byte pompam2 = D_pamet[2];
        byte pompam1 = D_pamet[1];
        byte pompam0 = D_pamet[0];
        interrupty();                                                        // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni

        D_pamet[0] = pompam0;                                                // po navratu z interruptu zobrazi puvodni stav displeje
        D_pamet[1] = pompam1;
        D_pamet[2] = pompam2;
        D_pamet[3] = pompam3;
        D_pamet[4] = pompam4;
        aktualizuj_displej();

        
        if (digitalRead(pin_tl_up) == LOW)                                   // listovani nahoru v polozce
          {
            delay(50);                                                       // odruseni zakmitu

            if (znak1 == 'S')                                                // casova zona je trochu jina, protoze nezobrazuje cisla, ale napisy SEC/SELC
              {
                vystup ++;
                if (vystup > maximum) vystup = maximum;
                zobraz_text(vystup+25);
              }
            else
              {
                pozice_tecky = 0;
                if (znak1 == 'L')
                  {
                    vystup --;
                    if (vystup < minimum) vystup = maximum;
                    zobraz_cislo(vystup,2);            
                    delay(50);                                               // odruseni zakmitu
                  }
                else
                  {
                    vystup ++;
                    if (vystup > maximum) vystup = minimum;
                    zobraz_cislo(vystup,1);
                  }
              }

            while (digitalRead(pin_tl_up) == LOW) delay(50);                 // dokud je tlacitko stisknute, nic se nedeje
            delay(50);                                                       // odruseni zakmitu
            auto_exit_menu = AUTOEXITMENU;
          }
    
        if (digitalRead(pin_tl_dn) == LOW)                                   // listovani dolu v polozce
          {
            delay(50);                                                       // odruseni zakmitu

            if (znak1 == 'S')                                                // casova zona je trochu jina, protoze nezobrazuje cisla, ale napisy SEC/SELC
              {
                vystup --;
                if (vystup < minimum) vystup = minimum;
                zobraz_text(vystup+25);
                delay(50);                                                   // odruseni zakmitu
              }
            else
              {
                pozice_tecky = 0;
                if (znak1 == 'L')
                  {
                    vystup ++;
                    if (vystup > maximum) vystup = minimum;
                    zobraz_cislo(vystup,2);            
                    delay(50);                                               // odruseni zakmitu
                  }
                else
                  {
                    vystup --;
                    if (vystup < minimum) vystup = maximum;
                    zobraz_cislo(vystup,1);
                    delay(50);                                               // odruseni zakmitu
                  }
              }

            
            while (digitalRead(pin_tl_dn) == LOW) delay(50);                 // dokud je tlacitko stisknute, nic se nedeje
            delay(50);                                                       // odruseni zakmitu
            auto_exit_menu = AUTOEXITMENU;    
          }

        if (digitalRead(pin_tl_ok) == LOW)                                   // potvrzovaci tlacitko v polozce
          {
            delay(50);                                                       // odruseni zakmitu
            unsigned long startTime = millis();
            while (digitalRead( pin_tl_ok) == LOW)                           // dokud je tlacitko stisknute, nic se nedeje
              {
                 delay(50);
                 trvani_stisku2 = millis() - startTime;
                 if (trvani_stisku2 > 500)
                   {
                     auto_exit_menu = AUTOEXITMENU;    
                     potvrzeni = true;
                     bude_save = true;
                     if (znak1 == 'L')
                       {
                         zobraz_text(29);                                    // napis "-----"
                       }
                     else
                       {
                         zobraz_text(16);                                    // napis "SAVE"
                       }
                     delay(500);
                     break;
                   }
              }
            if (trvani_stisku2 <= 500)                                       // stisk byl kratsi nez 0,5 sekundy
              {
                delay(200);                                                  // pauza pred opustenim menu
                vystup = start_hodnota;                                      // nastavene cislo se rusi a zustava puvodni
                potvrzeni = true;
                bude_save = false;
              }
          }      
      }
    return vystup;
  }
//------------------------------------------


//------------------------------------------
// podprogram pro postupne odrotovani zaznamu stopek na displeji
// vraci true pri predcasnem ukonceni rolovani pomoci tlacitka OK
//   nebo false po dobehnuti rolovani do konce
boolean disp_zaznam_scroll(byte pocet_znaku)
  {


    pom_disp_scroll[0] = 0;                                                  // prazdna sedmisegmentovka
    pom_disp_scroll[1] = 0;                                                  // prazdna sedmisegmentovka
    pom_disp_scroll[2] = 0;                                                  // prazdna sedmisegmentovka
    pom_disp_scroll[3] = 0;                                                  // prazdna sedmisegmentovka





    for (byte i = 0; i< pocet_znaku - 4 ; i++)
      {
        D_pamet[4] =  pom_disp_scroll[i];
        D_pamet[3] =  pom_disp_scroll[i+1];
        D_pamet[2] =  pom_disp_scroll[i+2];
        D_pamet[1] =  pom_disp_scroll[i+3];
        D_pamet[0] =  pom_disp_scroll[i+4];
        aktualizuj_displej();

        for (byte pauza = 0 ; pauza < 50 ; pauza++)
          {
            delay(10);
            if (i > 2 and digitalRead(pin_tl_ok) == LOW)
              {
                return true;
              }

            if (i > 2 and (digitalRead(pin_tl_dn) == LOW or digitalRead(pin_tl_up) == LOW) )
              {
                return false;
              }
          }
      }
    return false;
  }

#endif
