// USB seriova komunikace 
//================================================


//----------------------------------------------
// test, jestli pres USB seriovou komunikaci prisel nejaky pozadavek
void test_ser_kom(void)
  {
    if (Serial.available())
      {
        boolean chyba;
        char funkce = Serial.read();
    
        if (funkce == '?')                                                       // napoveda pro uzivatelske (bezne) funkce
          {
            ser_napoveda1();
          }
    
        if (funkce == '#')                                                       // vstup do podmenu servisnich funkci (malo pouzivane)
          {
            servisni_funkce();
          }

        if (funkce == '@')                                                       // vstup do podmenu tajnych funkci (prime rizeni systemu)
          {
            tajne_funkce();
          }


        
#ifndef senzor_nic
        if (funkce == USB_fce_1_01)                                              //'v'
          {
            Serial.print(lng001);                                                //  Serial.print("Vlhkost: ");
            
            Serial.print(citelna_vlhkost(vlhkost()));       
            Serial.println(" %");
          }
          
        if (funkce == USB_fce_1_02)                                              //'t'
          {
            unsigned int pom_teplota = teplota(false);
            Serial.print(lng002);                                                //  Serial.print("Teplota bez korekce: ");
            Serial.print(citelna_teplota(pom_teplota));
            Serial.println(" 'C");

            Serial.print(lng003);                                                //  Serial.print("Teplota s korekci podle tabulky: ");
            Serial.print(citelna_teplota(korekce_teploty(pom_teplota)));
            Serial.println(" 'C");          
          }
#endif
    
#ifdef senzor_BME
        if (funkce == USB_fce_1_03)                                              //'p'
          {
            Serial.print(lng004);                                                //  Serial.print("Absolutni tlak (bez prepoctu na hladinu more): ");
            Serial.print(citelny_tlak(tlak()));
            Serial.println(" Pa");                             
          }
#endif
    
    
    
        if (funkce == USB_fce_1_05)                                              // 'z' nastaveni zony (z 0 = SEC; z 1 = SELC)
          {
            delay(20);
            data = Serial.parseInt();                                            // precte nasledujici cislo (ignoruje pripadnou mezeru)
            Serial.print(lng005);                                                //  Serial.print("Nastavena zona ");
            if (data == 0)
              {
                leto = 0;
                Serial.println(lng006);                                          //  Serial.println("SEC.");
              }
            else
              {
                leto = 1;
                Serial.println(lng007);                                          //  Serial.println("SELC.");
              }
            EEPROM_update(8,leto);
          }
    
        if (funkce == USB_fce_1_04)                                              //  'l' zobraz svetlo (bez korekce i s korekci)
          {
            unsigned int pom_svetlo = svetlo_1x(false,false);
            Serial.print(lng008);                                                //  Serial.print("Plosny jas bez korekce: ");
            Serial.print(pom_svetlo / 1000.0, 3);
            Serial.println(" mag/arcsec2 ");

            Serial.print(lng009);                                                //  Serial.print("Plosny jas s korekci podle tabulky: ");
            Serial.print(korekce_svetla(pom_svetlo) / 1000.0, 3);
            Serial.println(" mag/arcsec2 ");

          }    


        if (funkce == USB_fce_1_06)                                              // 'a' nastaveni automatickeho mereni
          {
            delay(20);
            byte pomprom = Serial.parseInt();
            EEPROM_update(10,pomprom);
            automat = pomprom;
            if (automat == 0) Serial.println(lng010);                            //  Serial.println("Automat vypnuty");
            else
              {
                Serial.print(lng011);                                            //  Serial.print("Automaticky spoustet mereni po ");
                Serial.print(automat);
                Serial.println(" min.");             
                posledni_autospusteni = millis();                                // prvni mereni se spusti okamzite
                mereni(6);         
              }
          
          }


        if (pocet_cidel_svetla > 1 and funkce == USB_fce_1_07)                   // 'e'
          {
            byte pomprom = Serial.parseInt();
            prepni_cidlo_svetla(pomprom);
            Serial.print(lng012);                                                //  Serial.print("Aktualne je aktivni cidlo: ");
            Serial.println(index_cidla_svetla);
          }


        if (funkce == USB_fce_1_12)                                              // 'c'  zobrazi aktualni datum a cas
          {
            zobraz_RTC(leto , true);
          }


        if (funkce == USB_fce_1_13)                                              // 'i' informace o systemu (ulozene v EEPROM na adresach 0 az 19 )
          {
            sys_info();
          }

        if (funkce == USB_fce_1_14)                                              // 'h' vypis hlavicky do terminalu pro pripad, kdy se v terminalu zobrazuji jen hodnoty, ale neni videt, co znamenaji
          {
            Serial.println(hlavicka);
          }
    

        if (funkce == USB_fce_1_15)                                              // 'm' kompletni mereni s ulozenim do EEPROM (vysledek se nezobrazuje na displeji, jen se odesle do seriove linky)
          {
            mereni(4);
            
            if(dokoncene_mereni == 2)                                            // mereni dokonceno
              {
                Serial.println(hlavicka);
                Serial.println(vystupni_retezec);        
              }
          }


        if (funkce == USB_fce_1_08)                                              // 'r' cteni hodnot z EEPROM a jejich zobrazeni v terminalu
          {
            vypisove_funkce();
          }

        if (funkce == USB_fce_1_16)                                              // 'k' mereni a zobrazeni hodnot bez korekce
          {
            bezkorekcni_funkce();
          }

        while (Serial.available())  Serial.read();                               // pripadny zbytek dat v prijimacim bufferu se smaze

      }
  }
//----------------------------------------------



//----------------------------------------------
void vypisove_funkce(void)                                                       // funkce zacinala znakem 'r'
  {
    delay(10);
    if (Serial.available())                                                      // za znakem 'r' jeste neco nasleduje
      {
        char podfunkce = Serial.read();
        if (podfunkce == USB_fce_1_09)                                           // 'rp' = vypise posledni zaznam
          {
            vypis_EEPROM(65534);
          }
        if (podfunkce == USB_fce_1_10)                                           // 'ra' = vypise vsechny zaznamy
          {
            vypis_EEPROM(65533);
          }

        if (podfunkce == USB_fce_1_11)                                           // 'rz' = vypise jeden zvoleny zaznam
          {
            unsigned int polozka = Serial.parseInt();
            vypis_EEPROM(polozka);                                               // polozky jsou indexovane od 0 (prvni zaznam na adrese 500 ma index 0)
          }

        
      }
    else                                                                         // byla volana pouze funkce 'r' (vypis poslednich 100 zaznamu)
      {
        vypis_EEPROM(65535);        
      }
    
  }
//----------------------------------------------



//----------------------------------------------
void bezkorekcni_funkce(void)                                                    // funkce zacinala znakem 'k'
  {
    delay(10);
    if (Serial.available())                                                      // za znakem 'k' jeste neco nasleduje
      {
        char podfunkce = Serial.read();
        if (podfunkce == USB_fce_1_17)                                           // 'ks'   zobrazeni hodnoty svetla primo z cidla (bez kalibracni korekce)
          {
            Serial.print(lng013);                                                //  Serial.print("Plosny jas bez kalibracni korekce: ");
            mereni(8);
            if(dokoncene_mereni == 2)                                            // mereni dokonceno
              {
                unsigned int pom_svetlo = (pole_EEPROM[5] * 256) + pole_EEPROM[6];
                Serial.print(citelne_svetlo(pom_svetlo),3);
                Serial.println(" mag/arcsec2 ");          
              }
            
          }

#ifndef senzor_nic
        if (podfunkce == USB_fce_1_18)                                           // 'kt'    zobrazeni hodnoty teploty primo z cidla (bez kalibracni korekce)
          {
            Serial.print(lng014);                                                //  Serial.print("Teplota bez kalibracni korekce: ");
            unsigned int pom_teplota = teplota(false);
            Serial.print(pom_teplota);
            Serial.print("  =  ");
            Serial.print(citelna_teplota(pom_teplota));
            Serial.println("'C ");            
          }
#endif
      }
  }
//----------------------------------------------



//----------------------------------------------
void servisni_funkce(void)                                                       // funkce zacinala znakem '#'
  {
    delay(10);
    if (Serial.available())                                                      // za znakem '#' jeste neco nasleduje
      {
        char podfunkce = Serial.read();

        if (podfunkce == '?')                                                    // "#?" = napoveda pro servisni funkce
          {
            ser_napoveda2();
          }

        if (podfunkce == USB_fce_2_01)                                           // "#T" = nastaveni casu
          {
            nastav_RTC(leto);
            zobraz_RTC(leto , true);                                             // po nastaveni casu se ulozeny cas hned zobrazi
          }

      
        if (podfunkce == USB_fce_2_02)                                           // "#P" = nastaveni poctu prumerovani
          {
            delay(20);
            int pomprom = Serial.parseInt();
            if (pomprom >0 and pomprom < 21)
              {
                EEPROM_update(11,pomprom);
                prumery = pomprom;
                Serial.print(lng015);                                            //  Serial.print("Prumerovat ");
                Serial.print(prumery);
                Serial.println(lng016);                                          //  Serial.println(" mereni");
              }
            else
              {
                Serial.println(lng017);                                          //  Serial.println("Mimo rozsah (1-20)");
              }
          }

        if (podfunkce == USB_fce_2_03)                                           // "#S" = nastaveni urovne pro vyhodnoceni stabilniho jasu
          {
            delay(20);
            rozhod_stab = Serial.parseInt();
            EEPROM_update(16,rozhod_stab);
            Serial.print(lng018);                                                //  Serial.print("Rozhodovaci uroven pro stabilni jas je nastavena na ");
            Serial.print(rozhod_stab / 10.0,1);
            Serial.println(" %");
          }

        if (podfunkce == USB_fce_2_04)                                           // "#I" = informace o poslednim serizeni casu a o automaticke casove korekci
          {
            RTC_info(leto);
          }

        if (podfunkce == USB_fce_2_05)                                           // "#A" = nastaveni SLAVE adresy
          {
            delay(20);
            int pomprom = Serial.parseInt();
            if (pomprom >0 and pomprom < 16)
              {
                byte puvodni_baudrate = (EEPROM_read(14) & 0b00110000);
                slave_addr = pomprom;
                pomprom = pomprom | puvodni_baudrate;                
                EEPROM_update(14,pomprom);
                Serial.print(lng019);                                            //  Serial.print("SLAVE addr: ");
                Serial.print(pomprom & 0b00001111);
              }
            else
              {
                Serial.println(lng020);                                          //  Serial.println("Mimo rozsah (1-15)");
              }            
          }

        if (podfunkce == USB_fce_2_06)                                           // "#C" = zapnuti, nebo vypnuti kontroly prijimaneho CRC bajtu
          {
            delay(20);
            byte param = Serial.parseInt();
            if (param == 0) 
              {
                pouzij_CRC = 0;
                Serial.println(lng021);                                          //  Serial.println("CRC se nekontroluje");
                EEPROM_update(15,0);
              }
            if (param == 1)
              {
                pouzij_CRC = 1;
                Serial.println(lng022);                                          //  Serial.println("CRC se testuje");
                EEPROM_update(15,1);                
              }            
            if (param == 2)
              {
                pouzij_CRC = 2;
                Serial.println(lng023);                                          //  Serial.println("CRC se testuje, chyby se hlasi do USB seriove linky");
                EEPROM_update(15,2);                
              }            
          
          }

        if (podfunkce == USB_fce_2_07)                                           // "#O" = nastaveni oddelovacu pri vystupu zaznamu do terminalu, nebo na SD kartu
          {
            nastaveni_oddelovacu();
          }

        if (podfunkce == USB_fce_2_12)                                           // "#F" = format EEPROM
          {
            delay(20);
            if (Serial.available())
              {
                char param = Serial.read();
                if (param == USB_fce_2_13)                                       // "#FS"      SOFT format EEPROM
                  {
                    soft_format_EEPROM();
                  }

                if (param == USB_fce_2_14)                                       // "#FH"      HARD format EEPROM
                  {
                    hard_format_EEPROM();
                  }
              }
          }


        if (podfunkce == USB_fce_2_15)                                           // "#U" = hranice svetla pro ukladani zaznamu
          {
            delay(20);
            int pomprom = Serial.parseInt();
            if (pomprom < 255)
              {
                EEPROM_update(19,pomprom);
                hranice_ukladani = pomprom;
                Serial.print(lng024);                                            //  Serial.print("Do EEPROM se budou ukladat zaznamy s hodnotou plosneho jasu vetsi (tmavsi) nez ");
                Serial.print(hranice_ukladani / 10.0);
                Serial.println(" mag/arcsek2");
              }
            else
              {
                Serial.println(lng025);                                          //  Serial.println("Mimo rozsah (0-255)");
              }
          }


        if (podfunkce == USB_fce_2_16)                                           // "#K" = zadavani polozek kalibracnich tabulek
          {
            delay(20);
            if (Serial.available())
              {
                char param = Serial.read();
                if (param == USB_fce_2_17)                                       // "#KJ"      Kalibrace svetla
                  {
                    vstup_kalibrace_svetla();
                  }

                if (param == USB_fce_2_18)                                       // "#KT"      Kalibrace teploty
                  {
                    vstup_kalibrace_teploty();
                  }
              }
          }      
      
      }
    while (Serial.available())  Serial.read();                                   // pripadny zbytek dat v prijimacim bufferu se smaze
  }
//----------------------------------------------



//----------------------------------------------
void tajne_funkce(void)                                                          // funkce zacinala znakem '@'
  {
    delay(10);
    if (Serial.available())                                                      // za znakem '@' jeste neco nasleduje
      {
        char podfunkce = Serial.read();
        if (podfunkce == '?')                                                    // "@?" = napoveda pro tajne funkce
          {
            ser_napoveda3();
          }

        if (podfunkce == USB_fce_3_01)                                           // "@E" = test postupneho prepinani cidel na expanzni desce
          {
            prepni_cidlo_svetla();         
            Serial.print(lng012);                                                //  Serial.print("Aktualne je aktivni cidlo: ");
            Serial.println(index_cidla_svetla);
          }


        if (podfunkce == USB_fce_3_02)                                           // "@X" = nastaveni poctu vstupu na expanzni desce (1-7)
          {
            unsigned int pomprom = Serial.parseInt();
            if (pomprom < 7 and pomprom > 0)
              {
                EEPROM_update(17,pomprom);
                pocet_cidel_svetla = pomprom;
                Serial.print(lng026);                                            //  Serial.print("Zadany pocet vstupu pro cidla na expanzni desce: ");
                Serial.println(pocet_cidel_svetla);
                
              }
            else
              {
                Serial.println(lng027);                                          //  Serial.println("Zadany pocet vstupu je mimo rozsah (0 az 7)");
              }
          }


      
        if (podfunkce == USB_fce_3_03)                                           // "@R" = cteni z EEPROM
          {
            unsigned long adresa = Serial.parseInt();
            Serial.print("EEPROM[");
            Serial.print(adresa);
            Serial.print("] = ");
            Serial.println(EEPROM_read(adresa));

            if (adresa < 131071)
              {
                Serial.print("EEPROM[");
                Serial.print(adresa);
                Serial.print("] + [");
                Serial.print(adresa + 1);
                Serial.print("] = unsigned int ");
                Serial.println(EEPROM_read_int(adresa));

              }

          
          }
      
        if (podfunkce == USB_fce_3_04)                                           // "@W" = zapis do EEPROM
          {
            unsigned long adresa = Serial.parseInt();
            byte data = Serial.parseInt();
            Serial.print(lng028);                                                //  Serial.print(" puvodni: EEPROM[");
            Serial.print(adresa);
            Serial.print("] = ");
            Serial.print(EEPROM_read(adresa));

            EEPROM_write(adresa, data);

            Serial.print("   ->  ");
            Serial.println(EEPROM_read(adresa));
          }

        if (podfunkce == USB_fce_3_05)                                           // "@D" = obnoveni defaultnich hodnot
          {
            delay(20);
            if (Serial.available())
              {
                char param = Serial.read();
                if (param == USB_fce_3_06)                                       // "@DS"      obnoveni defaultnich kalibracnich hodnot svetla
                  {
                    default_kalibrace_svetla();
                    Serial.println(lng029);                                      //  Serial.println("Nastaveny defaultni kalibracni hodnoty pro cidlo jasu");
                  }

                if (param == USB_fce_3_07)                                       // "@DT"      obnoveni defaultnich kalibracnich hodnot teploty
                  {
                    default_kalibrace_teploty();
                    Serial.println(lng030);                                      //  Serial.println("Nastaveny defaultni kalibracni hodnoty pro teplotu");
                  }

                if (param == USB_fce_3_08)                                       // "@DP"      obnoveni defaultnich programovych konstant
                  {
                    default_parametry();
                    Serial.println(lng031);                                      //  Serial.println("Nastaveny defaultni parametry");
                  }
                
                if (param == USB_fce_3_06 or param == USB_fce_3_07 or param == USB_fce_3_08)       // automaticky reset po prenastaveni kalibrace
                  {
                    podfunkce = USB_fce_3_10;                                         
                  } 

              }

          }

        if (podfunkce == USB_fce_3_10)                                           // "@@" = softwarovy RESET pres vyprseni WD timeru
          {
            SOFT_RESET();
          }


        if (podfunkce == USB_fce_3_11)                                           // "@G" = vypis dat z GPS modulu
          {
            gps(false);
            
            Serial.print("GPS LAT: ");
            Serial.print(GPS_lat);
            Serial.print(" = ");
            unsigned long pom_prom_gps = GPS_lat;
            if (pom_prom_gps > 180000000UL)
              {
                Serial.println("Err");
              }
            else
              {
                if (pom_prom_gps > 90000000UL)
                  {
                    Serial.print("[N] ");
                    pom_prom_gps = pom_prom_gps - 90000000UL;   
                  }
                else
                  {
                    Serial.print("[S] ");
                  }
                float stupne = (pom_prom_gps / 1000000.0);
                Serial.println(stupne,6);
              }


            
            Serial.print("GPS LON: ");
            Serial.print(GPS_lon);
            Serial.print(" = ");
            pom_prom_gps = GPS_lon;
            if (pom_prom_gps > 360000000UL)
              {
                Serial.println("Err");
              }
            else
              {
                if (pom_prom_gps > 180000000UL)
                  {
                    Serial.print("[E] ");
                    pom_prom_gps = pom_prom_gps - 180000000UL;   
                  }
                else
                  {
                    Serial.print("[W] ");
                  }
                float stupne = (pom_prom_gps / 1000000.0);
                Serial.println(stupne,6);
              }

            
            Serial.print("GPS ALT: ");
            Serial.print(GPS_alt);
            Serial.print(" = ");
            if (GPS_alt > 10000)
              {
                Serial.println("Err");                
              }
            else
              {
                Serial.print(GPS_alt-500);
                Serial.println(" [m]");
              }


            Serial.print("GPS satelites: ");
            Serial.println(pole_GPS_I2C[17]);
            
            Serial.print("GPS HDoP: ");
            Serial.println(pole_GPS_I2C[18] / 10.0);

            Serial.print("GPS date: ");
            Serial.print(pole_GPS_I2C[11]);
            Serial.print('.');
            Serial.print(pole_GPS_I2C[10]);
            Serial.print('.');
            Serial.println(pole_GPS_I2C[9] + 2000);
            
            Serial.print("GPS time (UT): ");
            Serial.print(pole_GPS_I2C[12]);
            Serial.print(':');
            Serial.print(pole_GPS_I2C[13]);
            Serial.print(':');
            Serial.println(pole_GPS_I2C[14]);

            Serial.print("GPS OK cnt: ");
            Serial.println(pole_GPS_I2C[8]);

            Serial.print("GPS status: ");
            Serial.print(pole_GPS_I2C[19]);
            Serial.print("  (data: ");
            if ((pole_GPS_I2C[19] & 0b00000001) == 1) Serial.print("OK");
            else                                      Serial.print("--");
            Serial.print(" ; Time_Switch: ");
            if ((pole_GPS_I2C[19] & 0b00000010) == 2) Serial.print("ON");
            else                                      Serial.print("OFF");
            Serial.println(')');
            
          }

        if (podfunkce == USB_fce_3_12)                                           // "@S n" = nastaveni rychlosti komunikace
          {                                                                      //       (aaaa = SLAVE adresa)
                                                                                 // (0bxx00aaaa =   9600)
                                                                                 // (0bxx01aaaa =  19200)
                                                                                 // (0bxx10aaaa =  38400)
                                                                                 // (0bxx11aaaa = 115200)
            delay(20);
            byte baudrate = Serial.parseInt(); 
            if (baudrate < 4)
              {
                byte pomprom = EEPROM_read(14) & 0b00001111;                     // z EEPROM 14 se zachova pouze SLAVE adresa zarizeni
                baudrate = (baudrate << 4);                                      // zadane baudrate se posune na bity 4 a 5
                EEPROM_write(14, pomprom | baudrate);                            // spoji se s puvodni adresou a zapise se zpatky do EEPROM
                Serial.print("Baudrate: ");
                Serial.println(pole_baudrate[(baudrate >> 4)]);
                SOFT_RESET();
                
              }
          }


        if (podfunkce == USB_fce_3_09)                                           // "@T" = Test displeje nebo LED
          {
#ifdef signal_LED
            Serial.println(lng032);                                              //  Serial.println("LED by mely postupne blikat");
            for (byte i = 0 ; i< 5 ; i++)
              {
                blik_R();
                blik_G();
                blik_B();   
              }
            Serial.println(lng033);                                              //  Serial.println("Konec blikani LED");
#else
            Serial.println(lng034);                                              //  Serial.println("Test displeje");
            for (byte i = 0 ; i< 5 ; i++)
              {
                D_pamet[i] = 0;
              }
            D_pamet[0] = 255;
            aktualizuj_displej();
            delay(200);            
            D_pamet[1] = 255;
            aktualizuj_displej();
            delay(200);            
            D_pamet[2] = 255;
            aktualizuj_displej();
            delay(200);            
            D_pamet[3] = 255;
            aktualizuj_displej();
            delay(200);            
#ifdef  displej_TM1637_5 
            D_pamet[4] = 255;
            aktualizuj_displej();
            delay(200);            
#endif
            for (byte i = 0 ; i< 5 ; i++)
              {
                D_pamet[i] = 0;
              }
            aktualizuj_displej();
            Serial.println(lng035);                                              //  Serial.println("Konec testu displeje");
#endif
            
          }


        if (podfunkce == USB_fce_3_13)                                                    // "@-" = sken i2c
          {
            for (byte i = 1; i < 127; i++)
              {
                Wire.beginTransmission (i);
                if (Wire.endTransmission () == 0)
                  {
                    Serial.print ("Found address: ");
                    Serial.print (i, DEC);
                    Serial.print (" (0x");
                    Serial.print (i, HEX);
                    
                    Serial.print (") ");
                    switch(i)
                      {
                        case 23:  
                          Serial.print ("(GPS)");
                          break;

                        case 32:  
                          Serial.print ("(Expander)");
                          break;
                      
                        case 41:  
                          Serial.print ("(TSL2591)");
                          break;

                        case 80:  
                          Serial.print ("(EEPROM < 64kB)");
                          break;

                        case 81:  
                          Serial.print ("(EEPROM > 64kB)");
                          break;

                        case 87:  
                          Serial.print ("(Extra EEPROM)");
                          break;

                        case 118:  
                          Serial.print ("(BME280)");
                          break;
                      }
                    Serial.println (' ');

                    delay (1);  // maybe unneeded?
                  }
              }
         }
      }


    while (Serial.available())  Serial.read();                                   // pripadny zbytek dat v prijimacim bufferu se smaze  
  }
//----------------------------------------------



//----------------------------------------------
// napoveda pro uzivatelske funkce (casto pouzivane)
void ser_napoveda1(void)
  {
    Serial.println(lng036);                                                      //  Serial.println("l        ... zmer plosny jas  - bez ukladani");

#ifndef senzor_nic
    Serial.println(lng037);                                                      //  Serial.println("v        ... zmer vlhkost     - bez ukladani");
    Serial.println(lng038);                                                      //  Serial.println("t        ... zmer teplotu     - bez ukladani");
#endif
#ifdef senzor_BME
    Serial.println(lng039);                                                      //  Serial.println("p        ... zmer tlak        - bez ukladani");
#endif

    Serial.println(lng040);                                                      //  Serial.println("z 0      ... prepnout na SEC");
    Serial.println(lng041);                                                      //  Serial.println("z 1      ... prepnout na SELC");
  
    Serial.println(lng042);                                                      //  Serial.println("a nnn    ... nastaveni automatickeho spousteni 0-255 minut");

    if (pocet_cidel_svetla > 1)
      {
        Serial.println(lng043);                                                  //  Serial.println("e n      ... pri pouziti expanzni desky prepne na zvolene cidlo (1-7)");
      }
      
    Serial.println(lng044);                                                      //  Serial.println("r        ... vypis poslednich 100 zaznamu z EEPROM");
    Serial.println(lng045);                                                      //  Serial.println("rp       ... vypis posledniho zaznamu z EEPROM");
    Serial.println(lng046);                                                      //  Serial.println("ra       ... vypis vsech zaznamu z EEPROM");
    Serial.println(lng047);                                                      //  Serial.println("rz nnnnn ... vypis jednoho zvoleneho zazamu");

    Serial.println(lng048);                                                      //  Serial.println("c        ... aktualni cas");
    Serial.println(lng049);                                                      //  Serial.println("i        ... informace o aktualnim nastaveni systemu");

    Serial.println(lng050);                                                      //  Serial.println("h        ... zobrazeni hlavicky pro formatovany vystup");
    Serial.println(lng051);                                                      //  Serial.println("m        ... spusteni vsech mereni se zapisem do EEPROM");

    Serial.println(lng052);                                                      //  Serial.println("ks       ... kalibracni mereni jasu (vystup bez korekce)");
    Serial.println(lng053);                                                      //  Serial.println("kt       ... kalibracni mereni teploty (vystup bez korekce)");

    Serial.println(lng054);                                                      //  Serial.println("#?       ... napoveda pro servisni funkce");
  }
//----------------------------------------------



//----------------------------------------------
// napoveda pro servisni funkce
void ser_napoveda2(void)
  {
    Serial.println(lng055);                                                      //  Serial.println("#Tyyyymmddhhnnss ... nastaveni casu");

    Serial.println(lng056);                                                      //  Serial.println("#P nn        ... nastaveni poctu prumerovani jasu (1-20)");
    Serial.println(lng057);                                                      //  Serial.println("#S nnn       ... nastaveni urovne stability (0-255)");
    Serial.println(lng058);                                                      //  Serial.println("#I           ... detailni informace o kalibraci vnitrnich hodin");  
  
    Serial.println(lng059);                                                      //  Serial.println("#A nn        ... nastaveni SLAVE adresy pro komunikaci (1-15)");
    Serial.println(lng060);                                                      //  Serial.println("#C 0         ... vypnuti CRC kontroly pro RS485");
    Serial.println(lng061);                                                      //  Serial.println("#C 1         ... zapnuti CRC kontroly pro RS485");

    Serial.println(lng062);                                                      //  Serial.println("#O?          ... nastaveni oddelovacu");

    Serial.println(lng063);                                                      //  Serial.println("#FS          ... SOFT format EEPROM");
    Serial.println(lng064);                                                      //  Serial.println("#FH          ... HARD format EEPROM");

    Serial.println(lng065);                                                      //  Serial.println("#U           ... hranice jasu pro ukladani - v desetinach mag/arcsek2 (0-255)");

    Serial.println(lng066);                                                      //  Serial.println("#KS n;x;y*   ... zapis bodu do kalibracni tabulky jasu");
#ifndef senzor_nic
    Serial.println(lng067);                                                      //  Serial.println("#KT n;x;y*   ... zapis bodu do kalibracni tabulky teploty");
#endif
  }
//----------------------------------------------



//----------------------------------------------
// napoveda pro tajne funkce
void ser_napoveda3(void)
  {
    Serial.println(lng068);                                                      //  Serial.println("@W addr,data ... primy zapis do EEPROM");
    Serial.println(lng069);                                                      //  Serial.println("@R addr      ... prime cteni z EEPROM");

    Serial.println(lng070);                                                      //  Serial.println("@E           ... test postupneho prepinani cidel na expanzni desce");
    Serial.println(lng071);                                                      //  Serial.println("@X n         ... nastaveni poctu vstupu na expanzni desce (1-7)");

    Serial.println(lng072);                                                      //  Serial.println("@DS          ... defaultni kalibracni hodnoty pro jas");
    Serial.println(lng073);                                                      //  Serial.println("@DT          ... defaultni kalibracni hodnoty pro teplotu");
    Serial.println(lng074);                                                      //  Serial.println("@DP          ... defaultni parametry systemu");  
  
    Serial.println(lng075);                                                      //  Serial.println("@T           ... test displeje nebo LED");
    Serial.println(lng076);                                                      //  Serial.println("@@           ... softwarovy RESET");  
    Serial.println(lng208);                                                      //  Serial.println("@G           ... vypis dat z GPS modulu");  
    Serial.println(lng209);                                                      //  Serial.println("@S n         ... rychlost seriove komunikace (0=9600; 1=19200; 2=38400; 3=115200)");  
    Serial.println(lng211);                                                      //  Serial.println("@-           ... sken I2C sbernice");  
  }
//----------------------------------------------
  


//----------------------------------------------
void nastaveni_oddelovacu(void)
  {
    delay(20);
    char funkce = Serial.read();
    boolean chyba = true;
    
    if (funkce == USB_fce_2_08)                                                  // #OO
      {
       Serial.print(lng077);                                                     //  Serial.print("Oddelovac polozek: ");
        funkce = Serial.read();
        if(funkce == '_')                                                        // "#OO_"
          {
            oddelovac_polozek = 0;
            Serial.println(lng078);                                              //  Serial.println("mezera");            
            chyba = false;
          }
        if(funkce == ',')                                                        // "#OO,"
          {
            oddelovac_polozek = 1;
            Serial.println(lng079);                                              // Serial.println("carka");            
            chyba = false;
          }
        if(funkce == ';')                                                        // "#OO;"
          {
            oddelovac_polozek = 2;
            Serial.println(lng080);                                              //  Serial.println("strednik");            
            chyba = false;
          }
        if(funkce == 't')                                                        // "#OOt"
          {
            oddelovac_polozek = 3;
            Serial.println(lng081);                                              //  Serial.println("tabulator");            
            chyba = false;
          }
        funkce = 'X';                                                            // to jen aby se nevyhodnotila dalsi podminka
      }
  
    
    
    if (funkce == USB_fce_2_09)                                                  //  "#O,"
      {
        data = Serial.parseInt();
        Serial.print(lng082);                                                    //  Serial.print("Oddelovac desetinnych mist: ");
        if(data == 1)                                                            // "#O,1"
          {
            des_carka = true;
            Serial.println(lng079);                                              //  Serial.println("carka");            
          }
        else                                                                     // "#O,0"
          {
            des_carka = false;
            Serial.println(lng083);                                              //  Serial.println("tecka");
          }
        chyba = false;
        funkce = 'X';                                                            // to jen aby se nevyhodnotila dalsi podminka
      }

    if (funkce == USB_fce_2_10)                                                  //  "#O""
      {
        data = Serial.parseInt();
        if(data == 1)                                                            // "#O"1"
          {
            uzavirat_uvozovky = true;
            Serial.print(lng084);                                                //  Serial.print("Uzavirat");
          }
        else                                                                     // "#O"0"
          {
            uzavirat_uvozovky = false;
            Serial.print(lng085);                                                //  Serial.print("Neuzavirat");
          }
        Serial.println(lng086);                                                  //  Serial.println(" hodnoty do uvozovek");
        chyba = false;
        funkce = 'X';                                                            // to jen aby se nevyhodnotila dalsi podminka
      }

    if (funkce == USB_fce_2_11)                                                  // "#Oh"
      {
        data = Serial.parseInt();
        Serial.print(lng087);                                                    //  Serial.print("Na zacatku souboru se hlavicka vytvaret ");
        if(data == 1)                                                            // "#Oh1"
          {
            vytvaret_hlavicku = true;
            Serial.println(lng088);                                              //  Serial.println("bude.");
          }
        else                                                                     // "#Oh0"
          {
            vytvaret_hlavicku = false;
            Serial.println(lng089);                                              //  Serial.println("nebude.");
          }
        chyba = false;
      }

    if (chyba == true)
      {
        Serial.println(lng090);                                                  //  Serial.println("#O,1 ... des. oddelovac: carka");
        Serial.println(lng091);                                                  //  Serial.println("#O,0 ... des. oddelovac: tecka");
        Serial.println(lng092);                                                  //  Serial.println("#O\"1 ... uzavirat polozky do uvozovek");
        Serial.println(lng093);                                                  //  Serial.println("#O\"0 ... neuzavirat polozky do uvozovek");
        Serial.println(lng094);                                                  //  Serial.println("#Oh1 ... vytvaret hlavicky");
        Serial.println(lng095);                                                  //  Serial.println("#Oh0 ... nevytvaret hlavicky");
        Serial.println(lng096);                                                  //  Serial.println("#Oo_ ... oddelovac polozek: mezera");
        Serial.println(lng097);                                                  //  Serial.println("#Oo, ... oddelovac polozek: carka");
        Serial.println(lng098);                                                  //  Serial.println("#Oo; ... oddelovac polozek: strednik");
        Serial.println(lng099);                                                  //  Serial.println("#Oot ... oddelovac polozek: tabulator");        
      }
    else
      {
        oddelovaci_bajt = bitWrite(oddelovaci_bajt , 2 , des_carka);
        oddelovaci_bajt = bitWrite(oddelovaci_bajt , 3 , uzavirat_uvozovky);
        oddelovaci_bajt = bitWrite(oddelovaci_bajt , 4 , vytvaret_hlavicku);
        oddelovaci_bajt = oddelovaci_bajt & 0b11111100;
        oddelovaci_bajt = oddelovaci_bajt | oddelovac_polozek ;
        
        if (des_carka == true and oddelovac_polozek == 1)  Serial.println(lng100);    //  Serial.println("Varovani: oddelovac polozek i desetinnych mist je carka.");
        
        EEPROM_update(9 , oddelovaci_bajt);        

        if (uzavirat_uvozovky == true)  uvozovky = '"';
        else                            uvozovky = ' ';         

        if (des_carka == true)  desod = ',';
        else                    desod = '.';

      
      }    
  }
//----------------------------------------------



//----------------------------------------------
void vstup_kalibrace_svetla(void)
  {
    delay(50);                                                                   // v jednom bloku kalibracnich dat budou maximalne 3 radky tabulky (to je maximalne 3*15 = 45 bajtu, takze se to cele vejde do bufferu )

    for (byte i = 0 ; i < 15 ; i++)                                              // vsech 15 pomocnych promennych pro kalibracni tabulku se nastavi mimo rozsah 
      {
         kal_serial[i][0] = 65535;
         kal_serial[i][1] = 65535;
      }
    
    while (Serial.available())
      {
        delay(1);
        
        byte pozice_v_tabulce = Serial.parseInt(); 
        if (pozice_v_tabulce > 15 or pozice_v_tabulce < 1 )
          {
            Serial.println(lng101);                                              //  Serial.println("Vstup mimo rozsah (pozice 1 az 15)");
            break;
          }
        
        unsigned int kal_mereno =  Serial.parseInt(); 
        if (kal_mereno > 24000)
          {
            Serial.println(lng102);                                              //  Serial.println("Vstup mimo rozsah (merena hodnota max 24 mag/arcsek2 = 24000)");
            break;
          }
        
        unsigned int kal_skutecne =  Serial.parseInt(); 
        if (kal_skutecne > 24000)
          {
            Serial.println(lng103);                                              //  Serial.println("Vstup mimo rozsah (skutecna hodnota max 24 mag/arcsek2 = 24000)");
            break;
          }

        
        kal_serial[pozice_v_tabulce-1][0] = kal_mereno;                          // polozky, ktere byly zadane, se prepisi z 65535 na zadane hodnoty (muzou to byt i nuly)
        kal_serial[pozice_v_tabulce-1][1] = kal_skutecne;



        if (Serial.available())
          {
            char konec = Serial.read();                                          // precteni oddelovaciho stredniku nebo hvezdicky
            if (konec == '*')
              {
                Serial.println(lng104);                                          //  Serial.println("zadane kalibracni hodnoty pro plosny jas:");
                Serial.println(lng105);                                          //  Serial.println("pozice - merena hodnota - (mag/arcsek2) - spravna hodnota  - (mag/arcsek2)");
                unsigned int posun = ((index_cidla_svetla-1) * 60) + 50;         // podle aktualniho indexu cidla svetla se zvoli spravna oblast v EEPROM pro kalibracni tabulku
                for (byte i = 0 ; i < 15 ; i++)
                  {
                    if (kal_serial[i][0] != 65535 )                              // ty polozky, ktere byly prepsane z 65535 na neco jineho se zapisi do EEPROM
                      {
                        kal_svetlo[i][0] = kal_serial[i][0];
                        kal_svetlo[i][1] = kal_serial[i][1];
    
                        kal_serial[i][0] = 65535;
                        kal_serial[i][1] = 65535;


                        Serial.print(i+1);
                        Serial.print(" - ");

                        if (kal_svetlo[i][0] * kal_svetlo[i][1] > 0)             // obe zadane hodnoty do kalibracni tabulky byly nenulove
                          {
                            EEPROM_write_int(posun   +   (i * 4)   ,  kal_svetlo[i][0]); 
                            EEPROM_write_int(posun + 2 + (i * 4)   ,  kal_svetlo[i][1]); 

                            Serial.print( kal_svetlo[i][0]);
                            Serial.print(" - (");
                            Serial.print( citelne_svetlo(kal_svetlo[i][0]),3);
                            Serial.print(" mag/arcsek2) - ");
                            Serial.print( kal_svetlo[i][1]);
                            Serial.print(" - (");
                            Serial.print( citelne_svetlo(kal_svetlo[i][1]),3);
                            Serial.println(" mag/arcsek2)");                        
                          }
                        else                                                     // alespon 1 hodnota v kalibracnim bodu byla nulova, cely kalibracni bod se maze
                          {
                            EEPROM_write_int(posun   +   (i * 4)   ,  0); 
                            EEPROM_write_int(posun + 2 + (i * 4)   ,  0); 
                            kal_svetlo[i][0] = 0;
                            kal_svetlo[i][1] = 0;
                            Serial.println(lng210);                              //  "kalibracni bod smazan"
                          }
                      }
                  
                  }
                while (Serial.available()) Serial.read();                        // po hvezdicce se vsechno ostatni maze
              }
          }
      }
    test_korekcni_tabulky_svetla();                                              // zkontroluje spravne zadane udaje
  }
//----------------------------------------------



//----------------------------------------------
void vstup_kalibrace_teploty(void)
  {
    delay(50);                                                                   // v jednom bloku kalibracnich dat budou maximalne 4 radky tabulky (max 55 bajtu)

    for (byte i = 0 ; i < 15 ; i++)                                              // vsech 15 pomocnych promennych pro kalibracni tabulku se nastavi mimo rozsah 
      {
         kal_serial[i][0] = 65535;
         kal_serial[i][1] = 65535;
      }
    
    while (Serial.available())
      {
        delay(1);
        byte pozice_v_tabulce = Serial.parseInt();
        if (pozice_v_tabulce > 7 or pozice_v_tabulce < 1 )
          {
            Serial.println(lng106);                                              //  Serial.println("Vstup mimo rozsah (pozice 1 az 7)");
            break;
          }

        unsigned int kal_mereno =  Serial.parseInt(); 
        if (kal_mereno > 10000)
          {
            Serial.println(lng107);                                              //  Serial.println("Vstup mimo rozsah (merena hodnota max. 50'C = 10000)");
            break;
          }

        unsigned int kal_skutecne =  Serial.parseInt();
        if (kal_skutecne > 10000 )
          {
            Serial.println(lng108);                                              //  Serial.println("Vstup mimo rozsah (zobrazena hodnota max. 50'C = 10000)");
            break;
          }

        kal_serial[pozice_v_tabulce-1][0] = kal_mereno;                          // polozky, ktere byly zadane, se prepisi z 65535 na zadane hodnoty (muzou to byt i nuly)
        kal_serial[pozice_v_tabulce-1][1] = kal_skutecne;


        if (Serial.available())
          {
            char konec = Serial.read();                                          // precteni oddelovaciho stredniku nebo hvezdicky
            if (konec == '*')
              {
                Serial.println(lng109);                                          //  Serial.println("zadane kalibracni hodnoty pro teplotu:");
                Serial.println(lng110);                                          //  Serial.println("pozice / merena hodnota ('C) / zobrazena hodnota ('C)");
                for (byte i = 0 ; i < 7 ; i++)
                  {
                    if (kal_serial[i][0] != 65535 )
                      {
                        kal_teplota[i][0] = kal_serial[i][0];
                        kal_teplota[i][1] = kal_serial[i][1];

                        kal_serial[i][0] = 65535;
                        kal_serial[i][1] = 65535;
                        
                        Serial.print(i+1);
                        Serial.print(" / ");
                        
                        if (kal_teplota[i][0] * kal_teplota[i][1] > 0)           // obe zadane hodnoty do kalibracni tabulky byly nenulove    
                          {
                            EEPROM_write_int(20 + (i * 4)   ,  kal_teplota[i][0]); 
                            EEPROM_write_int(22 + (i * 4)   ,  kal_teplota[i][1]); 
                            
                            Serial.print( kal_teplota[i][0]);                    // merena teplota
                            Serial.print(" (= ");
                            Serial.print( citelna_teplota(kal_teplota[i][0]));   // (citelna merena teplota)
                            Serial.print(" 'C) / ");
                            Serial.print( kal_teplota[i][1]);                    // korekce
                            Serial.print(" (=");
                            Serial.print( citelna_teplota(kal_teplota[i][1]));   // (zkorigovana (spravna) citelna teplota)
                            Serial.println(" 'C)");
                          }
                        else
                          {
                            EEPROM_write_int(20 + (i * 4)   ,  0); 
                            EEPROM_write_int(22 + (i * 4)   ,  0); 
                            kal_teplota[i][0] = 0;
                            kal_teplota[i][1] = 0;
                            Serial.println(lng210);                              //  "kalibracni bod smazan"
                          }
                      }
                  }
                while (Serial.available()) Serial.read();                        // po hvezdicce se vsechno ostatni maze
              }
          }
      }
    test_korekcni_tabulky_teploty();                                             // zkontroluje spravne zadane udaje
  }
//----------------------------------------------






  
